(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: GENERUJ.PAS                                                    *)
(*  Obsah: program pro ulozeni rucne zadanych konstant do souboru          *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 21.6.2008                                             *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program ukladac_rozlozeni_klaves;

{vygeneruje datovy soubor potrebny pro praci programu OBRKLAV}

const posledni=16+21+21+16+17+10; {pocet klaves (celkem 101)}

      ns=23; {normalni sirka klavesy}
      nvr=ns+2; {normalni vodorovna roztec}
      nv=20; {normalni vyska}
      nsr=nv+2; {normalni svisla roztec}

      HsipkaZn=#24;
      DsipkaZn=#25;
      PsipkaZn=#26;
      LsipkaZn=#27;

{souradnice x:}
klx:array[1..posledni] of integer=({esc}0, {F1..F4}nvr+15,2*nvr+15,3*nvr+15,4*nvr+15, {F5..F8}6*nvr+5,7*nvr+5,8*nvr+5,9*nvr+5,
 {F9..F12}10*nvr+20,11*nvr+20,12*nvr+20,13*nvr+20, {prtscr..break}15*nvr+10,16*nvr+10,17*nvr+10,
 {~..bksp}0,nvr,2*nvr,3*nvr,4*nvr,5*nvr,6*nvr,7*nvr,8*nvr,9*nvr,10*nvr,11*nvr,12*nvr,13*nvr,
 {ins..pgup}15*nvr+10,16*nvr+10,17*nvr+10, {numlk..-}19*nvr,20*nvr,21*nvr,22*nvr,
 {tab..\}0,nvr+10,2*nvr+10,3*nvr+10,4*nvr+10,5*nvr+10,6*nvr+10,7*nvr+10,8*nvr+10,9*nvr+10,10*nvr+10,11*nvr+10,12*nvr+10,
 13*nvr+10, {del..pgdn}15*nvr+10,16*nvr+10,17*nvr+10, {7..+}19*nvr,20*nvr,21*nvr,22*nvr,
 {capslock..enter}0,nvr+15,2*nvr+15,3*nvr+15,4*nvr+15,5*nvr+15,6*nvr+15,7*nvr+15,8*nvr+15,9*nvr+15,10*nvr+15,11*nvr+15,
 12*nvr+15, {4..6}19*nvr,20*nvr,21*nvr,
 {shift..shift}0,2*nvr+3,3*nvr+3,4*nvr+3,5*nvr+3,6*nvr+3,7*nvr+3,8*nvr+3,9*nvr+3,10*nvr+3,11*nvr+3,12*nvr+3,
 {hsipka}16*nvr+10, {num.1..enter}19*nvr,20*nvr,21*nvr,22*nvr,
 {ctrl..ctrl}0,2*nvr+10,3*nvr+26,10*nvr+22,13*nvr+7, {lsipka..psipka}15*nvr+10,16*nvr+10,17*nvr+10,
 {0..,}19*nvr,21*nvr);

{souradnice y:}
kly:array[1..posledni] of integer=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
 nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,
 nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,nsr+10,
 2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,
 2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,2*nsr+10,
 3*nsr+10,3*nsr+10,3*nsr+10,3*nsr+10,3*nsr+10,3*nsr+10,3*nsr+10,3*nsr+10,
 3*nsr+10,3*nsr+10,3*nsr+10,3*nsr+10,3*nsr+10,3*nsr+10,3*nsr+10,3*nsr+10,
 4*nsr+10,4*nsr+10,4*nsr+10,4*nsr+10,4*nsr+10,4*nsr+10,4*nsr+10,4*nsr+10,4*nsr+10,
 4*nsr+10,4*nsr+10,4*nsr+10,4*nsr+10,4*nsr+10,4*nsr+10,4*nsr+10,4*nsr+10,
 5*nsr+10,5*nsr+10,5*nsr+10,5*nsr+10,5*nsr+10,5*nsr+10,5*nsr+10,5*nsr+10,5*nsr+10,5*nsr+10);

{sirky:}
kls:array[1..posledni] of byte=(ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,
 ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,2*ns-3,ns,ns,ns,ns,ns,ns,ns,
 ns+10,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns+10,ns,ns,ns,ns,ns,ns,ns,
 ns+15,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,2*ns+7,ns,ns,ns,
 2*ns+5,ns,ns,ns,ns,ns,ns,ns,ns,ns,ns,2*ns+19,ns,ns,ns,ns,ns,
 ns+13,ns+13,7*ns+5,ns+13,ns+13,ns,ns,ns,2*ns+2,ns);

{vysky:}
klv:array[1..posledni] of byte=(nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,
 nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,
 nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,2*nv+2,
 nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,
 nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,nv,2*nv+2,
 nv,nv,nv,nv,nv,nv,nv,nv,nv,nv);

{Urcite by ta pole sla nejak zkomprimovat, ale vsechna dohromady maji jenom
neco malo pres 1 KB a kdyz neprekazeji v datasegmentu, kaslu na to.}

{texty:}
klt:array[1..posledni] of string[5]=('Esc','F1','F2','F3','F4','F5','F6','F7','F8','F9','F10','F11','F12',
 'PSc','SLk','P/B',
 '`','1','2','3','4','5','6','7','8','9','0','-','=','BkSp','Ins','Hom','PgU','NLk','/','*','-',
 'Tab','Q','W','E','R','T','Y','U','I','O','P','[',']','\','Del','End','PgD','7','8','9','+',
 'CapLk','A','S','D','F','G','H','J','K','L',';','''','Enter','4','5','6',
 'Shift','Z','X','C','V','B','N','M',',','.','/','Shift',' '+hsipkazn,'1','2','3','Ent',
 'Ctrl','Alt','space','AltGr','Ctrl',' '+lsipkazn,' '+dsipkazn,' '+psipkazn,'0','.');

{scankody:}
sck:array[1..posledni] of byte=(1,59,60,61,62,63,64,65,66,67,68,87,88,55,70,29,
 41,2,3,4,5,6,7,8,9,10,11,12,13,14,210,199,201,69,181,55,74,
 15,16,17,18,19,20,21,22,23,24,25,26,27,43,211,207,209,71,72,73,78,
 58,30,31,32,33,34,35,36,37,38,39,40,28,75,76,77,
 42,44,45,46,47,48,49,50,51,52,53,54,200,79,80,81,156,
 29,56,57,184,157,203,208,205,82,83);

var f:file;

BEGIN
write('Tvorim soubor... ');
assign(f,'OBRKLAV.DAT');
rewrite(f,1);
blockwrite(f,klx,sizeof(klx));
blockwrite(f,kly,sizeof(kly));
blockwrite(f,kls,sizeof(kls));
blockwrite(f,klv,sizeof(klv));
blockwrite(f,klt,sizeof(klt));
blockwrite(f,sck,sizeof(sck));
close(f);
if ioresult=0 then writeln('hotovo.') else writeln('nepovedlo se!');
writeln('Konec po stisknuti Enteru.');
readln;
END.